//----------------------------------------------------------------------//
//	WIC ֘A															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <utilcls.h>
#include <System.StrUtils.hpp>
#include "usr_wic.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//ΉĂt@CH
//---------------------------------------------------------------------------
bool WIC_is_available(UnicodeString fnam)
{
	bool res = true;
	try {
		::CoInitialize(NULL);
		try {
			TComInterface<IWICImagingFactory>	factory;
			TComInterface<IWICBitmapDecoder>	decoder;

			if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
				CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
					Abort();

			if (FAILED(factory->CreateDecoderFromFilename(fnam.c_str(), NULL,
				GENERIC_READ, WICDecodeMetadataCacheOnDemand, &decoder)))
					Abort();

			UINT f_cnt;
			if (FAILED(decoder->GetFrameCount(&f_cnt))) Abort();
			if (f_cnt==0) Abort();
		}
		catch (EAbort &e) {
			res = false;
		}
		catch (...) {
			res = false;
		}
	}
	__finally {
		::CoUninitialize();
	}
	return res;
}

//---------------------------------------------------------------------------
//ew`ŃfR[hărbg}bv擾
//---------------------------------------------------------------------------
bool WIC_get_from_memory(TMemoryStream *ms, Graphics::TBitmap *o_bmp, GUID fmt)
{
	bool res = true;
	try {
		::CoInitialize(NULL);
		try {
			TComInterface<IWICImagingFactory>		factory;
			TComInterface<IWICStream>				stream;
			TComInterface<IWICBitmapDecoder>		decoder;
			TComInterface<IWICFormatConverter>		converter;
			TComInterface<IWICBitmapFrameDecode>	frame;

			if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
				CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
					Abort();

			if (FAILED(factory->CreateStream(&stream))) Abort();
			if (FAILED(stream->InitializeFromMemory(reinterpret_cast<BYTE*>(ms->Memory), ms->Size))) Abort();

			if (FAILED(factory->CreateDecoderFromStream(stream, &fmt,
				WICDecodeMetadataCacheOnLoad, &decoder)))
					Abort();

			if (FAILED(decoder->GetFrame( 0, &frame))) Abort();
			if (FAILED(factory->CreateFormatConverter(&converter))) Abort();

			if (FAILED(converter->Initialize(frame,
				GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
					Abort();

			//TCY擾
			UINT i_wd, i_hi;
			if (FAILED(converter->GetSize(&i_wd, &i_hi))) Abort();
			//C[WɃRs[
			UINT stride = i_wd * 3;
			std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
			if (FAILED(converter->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) Abort();
			//rbg}bvɃRs[
			o_bmp->PixelFormat = pf24bit;
			o_bmp->SetSize(i_wd, i_hi);
			BYTE *bp = ibuf.get();
			for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(o_bmp->ScanLine[i], bp, stride);
		}
		catch (EAbort &e) {
			res = false;
		}
		catch (...) {
			res = false;
		}
	}
	__finally {
		::CoUninitialize();
	}
	return res;
}

//---------------------------------------------------------------------------
//t@Cw肵ނ̃rbg}bv擾
// img_type : default = WICIMG_PREVIEW;
//---------------------------------------------------------------------------
bool WIC_load_image(UnicodeString fnam, Graphics::TBitmap *o_bmp, int img_type)
{
	bool res = true;
	try {
		::CoInitialize(NULL);
		try {
			TComInterface<IWICImagingFactory>		factory;
			TComInterface<IWICBitmapDecoder>		decoder;
			TComInterface<IWICFormatConverter>		converter;
			TComInterface<IWICBitmapFrameDecode>	frame;
			TComInterface<IWICBitmapSource> 		preview;
			TComInterface<IWICBitmapSource>			thumbnail;

			if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
				CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
					Abort();

			if (FAILED(factory->CreateDecoderFromFilename(fnam.c_str(), NULL,
				GENERIC_READ, WICDecodeMetadataCacheOnDemand, &decoder)))
					Abort();

			if (FAILED(factory->CreateFormatConverter(&converter))) Abort();

			HRESULT res = S_FALSE;
			if (img_type==WICIMG_THUMBNAIL) {
				//TlC擾
				res = decoder->GetThumbnail(&thumbnail);
				if (res==S_OK && FAILED(converter->Initialize(thumbnail,
					GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
						Abort();
			}
			if (res!=S_OK || img_type==WICIMG_PREVIEW) {
				//vr[擾
				res = decoder->GetPreview(&preview);
				if (res==S_OK && FAILED(converter->Initialize(preview,
					GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
						Abort();
			}
			if (res!=S_OK) {
				//t[擾
				res = decoder->GetFrame(0, &frame);
				if (res==S_OK && FAILED(converter->Initialize(frame,
					GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
						Abort();
			}
			if (FAILED(res)) Abort();

			//TCY擾
			UINT i_wd, i_hi;
			if (FAILED(converter->GetSize(&i_wd, &i_hi))) Abort();
			//C[WɃRs[
			UINT stride = i_wd * 3;
			std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
			if (FAILED(converter->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) Abort();
			//rbg}bvɃRs[
			o_bmp->PixelFormat = pf24bit;
			o_bmp->SetSize(i_wd, i_hi);
			BYTE *bp = ibuf.get();
			for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(o_bmp->ScanLine[i], bp, stride);
		}
		catch (EAbort &e) {
			res = false;
		}
		catch (...) {
			res = false;
		}
	}
	__finally {
		::CoUninitialize();
	}
	return res;
}

//---------------------------------------------------------------------------
//rbg}bvw`Ńt@Cɕۑ
//   img_q : jpeg 掿				(0`100 default = 100)
//    ycrcb: jpeg TuTvO	(0`3	default = 0)
// cmp_mode: tiff k				(0`7   default = 0)
//---------------------------------------------------------------------------
bool WIC_save_image(UnicodeString fnam, Graphics::TBitmap *i_bmp,
	int img_q, int ycrcb, int cmp_mode)
{
	UnicodeString fext = ExtractFileExt(fnam) + ".";
	GUID fmt;
	if		(ContainsText(".BMP.", fext))			fmt = GUID_ContainerFormatBmp;
	else if (ContainsText(".JPG.JPEG.JPE.", fext))	fmt = GUID_ContainerFormatJpeg;
	else if (ContainsText(".PNG.", fext))			fmt = GUID_ContainerFormatPng;
	else if (ContainsText(".GIF.", fext))			fmt = GUID_ContainerFormatGif;
	else if (ContainsText(".TIF.", fext))			fmt = GUID_ContainerFormatTiff;
	else if (ContainsText(".HDP.WDP.", fext))		fmt = GUID_ContainerFormatWmp;
	else return false;

	bool res = true;
	try {
		::CoInitialize(NULL);
		try {
			TComInterface<IWICImagingFactory>		factory;
			TComInterface<IWICStream>				stream;
			TComInterface<IWICBitmapEncoder>		encoder;
			TComInterface<IWICBitmap>				bitmap;
			TComInterface<IWICBitmapFrameEncode>	frame;
			TComInterface<IPropertyBag2>			properties;

			if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
				CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
					Abort();

			if (FAILED(factory->CreateStream(&stream)))							Abort();
			if (FAILED(stream->InitializeFromFilename(fnam.c_str(), GENERIC_WRITE))) Abort();
			if (FAILED(factory->CreateEncoder(fmt, NULL, &encoder)))			Abort();
	        if (FAILED(encoder->Initialize(stream, WICBitmapEncoderNoCache)))	Abort();
			if (FAILED(encoder->CreateNewFrame(&frame, &properties)))			Abort();

			//IvVݒ
			PROPBAG2 option = { 0 };
			VARIANT varValue;
			//JpegAHDP: i
			if (fmt==GUID_ContainerFormatJpeg || fmt==GUID_ContainerFormatWmp) {
				option.pstrName = L"ImageQuality";
				VariantInit(&varValue);
				varValue.vt 	= VT_R4;
				varValue.fltVal = (float)((img_q<100)? img_q/100.0 : 1.0);
				if (FAILED(properties->Write(1, &option, &varValue))) Abort();
			}
			//JpegP: YCrCb TuTvO
			if (fmt==GUID_ContainerFormatJpeg && ycrcb>=0 && ycrcb<=3) {
				option.pstrName = L"JpegYCrCbSubsampling";
				VariantInit(&varValue);
				varValue.vt 	= VT_UI1;
				varValue.bVal	= ycrcb;
				if (FAILED(properties->Write(1, &option, &varValue))) Abort();
			}
			//Tiff: k@
			if (fmt==GUID_ContainerFormatTiff && cmp_mode>=0 && cmp_mode<=7) {
				option.pstrName = L"TiffCompressionMethod";
				VariantInit(&varValue);
				varValue.vt 	= VT_UI1;
				varValue.bVal	= cmp_mode;
				if (FAILED(properties->Write(1, &option, &varValue))) Abort();
			}

			if (FAILED(frame->Initialize(properties)))	Abort();

			//\[Xrbg}bv쐬
			if (FAILED(factory->CreateBitmapFromHBITMAP(
				i_bmp->Handle, NULL, WICBitmapIgnoreAlpha, &bitmap)))
					Abort();

			if (FAILED(frame->WriteSource(bitmap, 0)))	Abort();
			if (FAILED(frame->Commit()))				Abort();
			if (FAILED(encoder->Commit()))				Abort();
		}
		catch (EAbort &e) {
			res = false;
		}
		catch (...) {
			res = false;
		}
	}
	__finally {
		::CoUninitialize();
	}
	return res;
}

//---------------------------------------------------------------------------
//摜̏kEg
//  i_bmp : ̓rbg}bv
//  o_bmp : o̓rbg}bv
//
//	ratio : {		0.0 : 
//   s_wd : TCY	  0 : 
//   s_hi : cTCY
//			{TCŶꂩw
//   s_opt: ASY
//---------------------------------------------------------------------------
bool WIC_resize_image(Graphics::TBitmap *i_bmp, Graphics::TBitmap *o_bmp,
	double ratio, unsigned int s_wd, unsigned int s_hi, int s_opt)
{
	if (ratio<=0.0 && (s_wd==0 || s_hi==0)) return false;

	bool res = true;
	try {
		::CoInitialize(NULL);
		try {
			TComInterface<IWICImagingFactory>	factory;
			TComInterface<IWICBitmap>			bitmap;
			TComInterface<IWICBitmapScaler> 	scaler;

			if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
				CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
					Abort();

			//\[Xrbg}bv쐬
			i_bmp->PixelFormat = pf24bit;
			if (FAILED(factory->CreateBitmapFromHBITMAP(
				i_bmp->Handle, NULL, WICBitmapIgnoreAlpha, &bitmap)))
					Abort();

			if (FAILED(factory->CreateBitmapScaler(&scaler))) Abort();

			//TCY
			UINT i_wd, i_hi;
			if (ratio>0) {
				i_wd = i_bmp->Width  * ratio;
				i_hi = i_bmp->Height * ratio;
			}
			else {
				i_wd = s_wd;
				i_hi = s_hi;
			}
			WICBitmapInterpolationMode opt;
			switch (s_opt) {
			case 1:  opt = WICBitmapInterpolationModeLinear; break;		//oCjA
			case 2:  opt = WICBitmapInterpolationModeCubic;	 break;		//oCL[rbN
			case 3:  opt = WICBitmapInterpolationModeFant;	 break;		//t@gTvO
			default: opt = WICBitmapInterpolationModeNearestNeighbor;	//ŋߖT@
			}
			if (FAILED(scaler->Initialize(bitmap, i_wd, i_hi, opt)))
				Abort();

			//C[WɃRs[
			UINT stride = i_wd * 3;
			std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
			if (FAILED(scaler->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) Abort();
			//rbg}bvɃRs[
			o_bmp->PixelFormat = pf24bit;
			o_bmp->SetSize(i_wd, i_hi);
			BYTE *bp = ibuf.get();
			for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(o_bmp->ScanLine[i], bp, stride);
		}
		catch (EAbort &e) {
			res = false;
		}
		catch (...) {
			res = false;
		}
	}
	__finally {
		::CoUninitialize();
	}
	return res;
}

//---------------------------------------------------------------------------
//摜̉]E]
// rot_opt : 1:90/ 2:180/ 3:270(90)/ 4:E]/ 5:㉺]
//---------------------------------------------------------------------------
bool WIC_rotate_image(Graphics::TBitmap *i_bmp, int rot_opt)
{
	bool res = true;
	try {
		::CoInitialize(NULL);
		try {
			TComInterface<IWICImagingFactory>		factory;
			TComInterface<IWICBitmap>				bitmap;
			TComInterface<IWICBitmapFlipRotator> 	rotator;

			if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
				CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
					Abort();

			//\[Xrbg}bv쐬
			i_bmp->PixelFormat = pf24bit;
			if (FAILED(factory->CreateBitmapFromHBITMAP(i_bmp->Handle, NULL,
				WICBitmapIgnoreAlpha, &bitmap)))
					Abort();

			//]
			if (FAILED(factory->CreateBitmapFlipRotator(&rotator))) Abort();
			WICBitmapTransformOptions opt;
			switch (rot_opt) {
			case  1: opt = WICBitmapTransformRotate90;	break;
			case  2: opt = WICBitmapTransformRotate180;	break;
			case  3: opt = WICBitmapTransformRotate270;	break;
			case  4: opt = WICBitmapTransformFlipHorizontal;	break;
			case  5: opt = WICBitmapTransformFlipVertical;		break;
			default: opt = WICBitmapTransformRotate0;	break;
	 		}
			if (FAILED(rotator->Initialize(bitmap, opt))) Abort();

			//TCY擾
			UINT i_wd, i_hi;
			if (FAILED(rotator->GetSize(&i_wd, &i_hi))) Abort();
			//C[WɃRs[
			UINT stride = i_wd * 3;
			std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
			if (FAILED(rotator->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) Abort();
			//rbg}bvɃRs[
			i_bmp->PixelFormat = pf24bit;
			i_bmp->SetSize(i_wd, i_hi);
			BYTE *bp = ibuf.get();
			for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(i_bmp->ScanLine[i], bp, stride);
		}
		catch (EAbort &e) {
			res = false;
		}
		catch (...) {
			res = false;
		}
	}
	__finally {
		::CoUninitialize();
	}
	return res;
}

//---------------------------------------------------------------------------
//O[XP[
//---------------------------------------------------------------------------
bool WIC_grayscale_image(Graphics::TBitmap *i_bmp)
{
	bool res = true;
	try {
		::CoInitialize(NULL);
		try {
			TComInterface<IWICImagingFactory>		factory;
			TComInterface<IWICBitmap>				bitmap;
			TComInterface<IWICFormatConverter>		g_converter;
			TComInterface<IWICFormatConverter>		o_converter;

			if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
				CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
					Abort();

			//\[Xrbg}bv쐬
			if (FAILED(factory->CreateBitmapFromHBITMAP(i_bmp->Handle, NULL, WICBitmapIgnoreAlpha, &bitmap)))
				Abort();
			//O[XP[ɕϊ
			if (FAILED(factory->CreateFormatConverter(&g_converter))) Abort();
			if (FAILED(g_converter->Initialize(bitmap,
				GUID_WICPixelFormat8bppGray, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
					Abort();
			//24bit BGR ɕϊ
			if (FAILED(factory->CreateFormatConverter(&o_converter))) Abort();
			if (FAILED(o_converter->Initialize(g_converter,
				GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
					Abort();

			//TCY擾
			UINT i_wd, i_hi;
			if (FAILED(o_converter->GetSize(&i_wd, &i_hi))) Abort();
			//C[WɃRs[
			UINT stride = i_wd * 3;
			std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
			if (FAILED(o_converter->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) Abort();
			//rbg}bvɃRs[
			i_bmp->PixelFormat = pf24bit;
			i_bmp->SetSize(i_wd, i_hi);
			BYTE *bp = ibuf.get();
			for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(i_bmp->ScanLine[i], bp, stride);
		}
		catch (EAbort &e) {
			res = false;
		}
		catch (...) {
			res = false;
		}
	}
	__finally {
		::CoUninitialize();
	}
	return res;
}

//---------------------------------------------------------------------------
//摜̃TCY擾
// img_type : default = WICIMG_PREVIEW;
//---------------------------------------------------------------------------
bool WIC_get_img_size(UnicodeString fnam, unsigned int *wd, unsigned int *hi)
{
	bool res = true;
	try {
		::CoInitialize(NULL);
		try {
			TComInterface<IWICImagingFactory>		factory;
			TComInterface<IWICBitmapDecoder>		decoder;
			TComInterface<IWICBitmapFrameDecode>	frame;

			if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
				CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
					Abort();

			if (FAILED(factory->CreateDecoderFromFilename(fnam.c_str(), NULL,
				GENERIC_READ, WICDecodeMetadataCacheOnDemand, &decoder)))
					Abort();

			if (FAILED(decoder->GetFrame(0, &frame)))	Abort();
			if (FAILED(frame->GetSize(wd, hi)))			Abort();
		}
		catch (EAbort &e) {
			res = false;
		}
		catch (...) {
			res = false;
		}
	}
	__finally {
		::CoUninitialize();
	}
	return res;
}
//---------------------------------------------------------------------------
